=== debian/changelog ===
wcd (5.2.5-1build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 09:47:17 +0000

wcd (5.2.5-1) unstable; urgency=low

  * New upstream release.
  * debian/control
    - (Standards-Version): Update to 3.9.5.
  * debian/rules
    - Adjust for new release.
  * debian/watch
    - Drop *-src from URLs.

 -- Jari Aalto <jari.aalto@cante.net>  Fri, 13 Jun 2014 05:34:59 +0300
