=== debian/watch ===
version=3
http://www.xs4all.nl/~waterlan/ wcd-([.\d]*)\.tar\.gz
# http://sf.net/wcd/wcd-([.\d]*)\.tar\.gz
